
-- Thank you so much Sokolov

local math_clamp = math.clamp
local math_lerp = math.lerp
local math_max = math.max
local math_min = math.min
local math_random = math.random
local mrot_axis_angle = mrotation.set_axis_angle
local mvec3_add = mvector3.add
local mvec3_cross = mvector3.cross
local mvec3_dir = mvector3.direction
local mvec3_dot = mvector3.dot
local mvec3_norm = mvector3.normalize
local mvec3_rot = mvector3.rotate_with
local mvec3_set = mvector3.set
local mvec3_set_l = mvector3.set_length
local mvec3_set_z = mvector3.set_z
local mvec3_sub = mvector3.subtract
local temp_rot1 = Rotation()
local temp_vec1 = Vector3()
local temp_vec2 = Vector3()

function CopActionShoot:anim_clbk_melee_strike()
    if not alive(self._melee_unit) then
        return
    end
 
    local target_vec = temp_vec1
    local target_dis = mvec3_dir(target_vec, self._shoot_from_pos, self._melee_unit:movement():m_head_pos())
    local max_dis = 150
    if target_dis >= max_dis then
        return
    end
 
    local tar_vec_flat = temp_vec2
    mvec3_set(tar_vec_flat, target_vec)
    mvec3_set_z(tar_vec_flat, 0)
    mvec3_norm(tar_vec_flat)
 
    local fwd = self._common_data.fwd
    local fwd_dot = mvec3_dot(fwd, tar_vec_flat)
    local min_dot = math.lerp(0.1, 0.5, target_dis / max_dis)
    if fwd_dot < min_dot then
        return
    end
 
    local defense_data = self._melee_unit:character_damage():damage_melee({
        variant = "melee",
        damage = (self._w_usage_tweak.melee_dmg or 10) * (1 + self._unit:base():get_total_buff("base_damage")),
        weapon_unit = self._weapon_unit,
        attacker_unit = self._common_data.unit,
        melee_weapon = self._unit:base():melee_weapon(),
        push_vel = target_vec:with_z(0.1):normalized() * 500,
        col_ray = {
            position = self._shoot_from_pos + fwd * 50,
            ray = mvector3.copy(target_vec),
            body = self._melee_unit:body(0)
        }
    })
 
    if defense_data == "countered" then
        self._common_data.melee_countered_t = TimerManager:game():time()
        self._unit:character_damage():damage_melee({
            damage_effect = 1,
            damage = 0,
            variant = "counter_spooc",
            attacker_unit = self._melee_unit,
            col_ray = {
                body = self._unit:body(0),
                position = self._common_data.pos + math.UP * 100
            },
            attack_dir = -1 * target_vec:normalized(),
            name_id = managers.blackmarket:equipped_melee_weapon()
        })
    end
end

function CopActionShoot:_chk_start_melee(t, target_dis)
    if target_dis > 100 or not self._w_usage_tweak.melee_speed then
        return
    end
 
    if self._melee_timeout_t > t or self._common_data.melee_countered_t and t - self._common_data.melee_countered_t < 15 then
        return
    end
 
    local attention_unit = self._attention.unit
    if not attention_unit or not attention_unit:character_damage() or not attention_unit:character_damage().damage_melee then
        return
    end
 
    local melee_weapon = self._unit:base():melee_weapon()
    local is_weapon = melee_weapon == "weapon"
    local state = self._ext_movement:play_redirect(is_weapon and "melee" or "melee_item")
    if not state then
        return
    end
 
    if not is_weapon then
        local anim_attack_vars = self._common_data.char_tweak.melee_anims or { "var1", "var2" }
        local melee_var = self:_pseudorandom(#anim_attack_vars)
        self._common_data.machine:set_parameter(state, anim_attack_vars[melee_var], 1)
 
        local param = tweak_data.weapon.npc_melee[melee_weapon].animation_param
        self._common_data.machine:set_parameter(state, param, 1)
    end
 
    self._common_data.machine:set_speed(state, self._w_usage_tweak.melee_speed)
 
    local retry_delay = self._w_usage_tweak.melee_retry_delay
    self._melee_timeout_t = t + (retry_delay and math.lerp(retry_delay[1], retry_delay[2], self:_pseudorandom()) or 1)
 
    -- Set melee unit if we should process damage for it (server and not shooting a client, or client and shooting the local player)
    local is_server = Network:is_server()
    self._melee_unit = (is_server and not self._shooting_husk_player or not is_server and self._shooting_player) and attention_unit
 
    return true
end

