-- Count bots for crew alive bonus
local on_executed_original = ElementMissionEnd.on_executed
function ElementMissionEnd:on_executed(instigator, ...)
	if not self._values.enabled or self._values.state ~= "success" or managers.platform:presence() ~= "Playing" then
		return on_executed_original(self, instigator, ...)
	end

	local num_winners = managers.network:session():amount_of_alive_players() + managers.groupai:state():amount_of_winning_ai_criminals()

	managers.network:session():send_to_peers("mission_ended", true, num_winners)
	game_state_machine:change_state_by_name("victoryscreen", {
		num_winners = num_winners,
		personal_win = alive(managers.player:player_unit())
	})

	ElementMissionEnd.super.on_executed(self, instigator)
end


if RequiredScript == "lib/managers/mission/elementmissionend" then
    local is_offline = Global and Global.game_settings and Global.game_settings.single_player
    function ElementMissionEnd:on_executed(instigator)
        if not self._values.enabled then
            return
        end
        if self._values.state ~= "none" and managers.platform:presence() == "Playing" then
            if self._values.state == "success" then
                local num_winners = managers.network:session():amount_of_alive_players()
                if is_offline then
                    num_winners = managers.network:session():amount_of_alive_players() + managers.groupai:state():amount_of_winning_ai_criminals()
                end
                managers.network:session():send_to_peers("mission_ended", true, num_winners)
                game_state_machine:change_state_by_name("victoryscreen", {
                    num_winners = num_winners,
                    personal_win = alive(managers.player:player_unit())
                })
            elseif self._values.state == "failed" then
                managers.network:session():send_to_peers("mission_ended", false, 0)
                game_state_machine:change_state_by_name("gameoverscreen")
            elseif self._values.state == "leave" then
                MenuCallbackHandler:leave_mission()
            elseif self._values.state == "leave_safehouse" and instigator:base().is_local_player then
                MenuCallbackHandler:leave_safehouse()
            end
        elseif Application:editor() then
            managers.editor:output_error("Cant change to state " .. self._values.state .. " in mission end element " .. self._editor_name .. ".")
        end
        ElementMissionEnd.super.on_executed(self, instigator)
    end
end
